#include "PrefsPanel/AC3EdDownMixView.h"
#include "Preferences.h"


AC3EdDownMixView::AC3EdDownMixView(BRect frame, const char *name, uint32 resizingMode, uint32 flags) :
	BView(frame, name, resizingMode, flags)
{
}

AC3EdDownMixView::~AC3EdDownMixView()
{
}

void AC3EdDownMixView::SetGainSliderLabel()
{
	char Label[100];
	
	sprintf (Label, "Gain Level (%d%%)", ThePrefs->GainLevelPercent());
	GainLevelSlider->SetLabel(Label);
	sprintf (Label, "Gain 2 Level (%d%%)", ThePrefs->Gain2LevelPercent());
	Gain2LevelSlider->SetLabel(Label);
	sprintf (Label, "Gain Center (%d%%)", ThePrefs->GainCenterPercent());
	GainCenterSlider->SetLabel(Label);
	sprintf (Label, "Gain Rear (%d%%)", ThePrefs->GainRearPercent());
	GainRearSlider->SetLabel(Label);
	sprintf (Label, "Gain Lfe (%d%%)", ThePrefs->GainLfePercent());
	GainLfeSlider->SetLabel(Label);
}

void AC3EdDownMixView::AttachedToWindow()
{
	if ( Parent() )
		SetViewColor(Parent()->ViewColor());

	rgb_color kColor = {5,5,255,255};

	BRect R= Bounds();
	R.top+= 5;
	R.left+= 5;
	R.bottom= 50 + R.top;
	R.right-= 5;
	
	GainLevelSlider= new BSlider(R, "", "", new BMessage(M_SLIDER_GAIN_LEVEL), 0, 100);
	GainLevelSlider->SetLimitLabels("0%", "100%");
	GainLevelSlider->SetHashMarks(B_HASH_MARKS_BOTTOM);
	GainLevelSlider->SetHashMarkCount(6);
	GainLevelSlider->UseFillColor(true,&kColor);
	GainLevelSlider->SetValue(ThePrefs->GainLevelPercent());
	
	AddChild(GainLevelSlider);
	GainLevelSlider->SetTarget(this);
	
	R.top= R.bottom + 5;
	R.bottom= 50 + R.top;
		
	Gain2LevelSlider= new BSlider(R, "", "", new BMessage(M_SLIDER_GAIN2_LEVEL), 0, 500);
	Gain2LevelSlider->SetLimitLabels("0%", "500%");
	Gain2LevelSlider->SetHashMarks(B_HASH_MARKS_BOTTOM);
	Gain2LevelSlider->SetHashMarkCount(6);
	Gain2LevelSlider->UseFillColor(true,&kColor);
	Gain2LevelSlider->SetValue(ThePrefs->Gain2LevelPercent());
	
	AddChild(Gain2LevelSlider);
	Gain2LevelSlider->SetTarget(this);
	
	R.top= R.bottom + 5;
	R.bottom= 50 + R.top;
	
	GainCenterSlider= new BSlider(R, "", "", new BMessage(M_SLIDER_GAIN_CENTER), 0, 500);
	GainCenterSlider->SetLimitLabels("0%", "500%");
	GainCenterSlider->SetHashMarks(B_HASH_MARKS_BOTTOM);
	GainCenterSlider->SetHashMarkCount(6);
	GainCenterSlider->UseFillColor(true,&kColor);
	GainCenterSlider->SetValue(ThePrefs->GainCenterPercent());
	
	AddChild(GainCenterSlider);
	GainCenterSlider->SetTarget(this);
	
	R.top= R.bottom + 5;
	R.bottom= 50 + R.top;
	
	GainRearSlider= new BSlider(R, "", "", new BMessage(M_SLIDER_GAIN_REAR), 0, 500);
	GainRearSlider->SetLimitLabels("0%", "500%");
	GainRearSlider->SetHashMarks(B_HASH_MARKS_BOTTOM);
	GainRearSlider->SetHashMarkCount(6);
	GainRearSlider->UseFillColor(true,&kColor);
	GainRearSlider->SetValue(ThePrefs->GainRearPercent());
	
	AddChild(GainRearSlider);
	GainRearSlider->SetTarget(this);
	
	R.top= R.bottom + 5;
	R.bottom= 50 + R.top;
	
	GainLfeSlider= new BSlider(R, "", "", new BMessage(M_SLIDER_GAIN_LFE), 0, 500);
	GainLfeSlider->SetLimitLabels("0%", "500%");
	GainLfeSlider->SetHashMarks(B_HASH_MARKS_BOTTOM);
	GainLfeSlider->SetHashMarkCount(6);
	GainLfeSlider->UseFillColor(true,&kColor);
	GainLfeSlider->SetValue(ThePrefs->GainLfePercent());
	
	AddChild(GainLfeSlider);
	GainLfeSlider->SetTarget(this);
	
	SetGainSliderLabel();
}

void AC3EdDownMixView::UpdateControls()
{
}

void AC3EdDownMixView::MessageReceived(BMessage *message)
{
	switch ( message->what ) {
		case M_SLIDER_GAIN_LEVEL:
			ThePrefs->SetGainLevelPercent(GainLevelSlider->Value());
			SetGainSliderLabel();
			break;
		case M_SLIDER_GAIN2_LEVEL:
			ThePrefs->SetGain2LevelPercent(Gain2LevelSlider->Value());
			SetGainSliderLabel();
			break;
		case M_SLIDER_GAIN_CENTER:
			ThePrefs->SetGainCenterPercent(GainCenterSlider->Value());
			SetGainSliderLabel();
			break;
		case M_SLIDER_GAIN_REAR:
			ThePrefs->SetGainRearPercent(GainRearSlider->Value());
			SetGainSliderLabel();
			break;
		case M_SLIDER_GAIN_LFE:
			ThePrefs->SetGainLfePercent(GainLfeSlider->Value());
			SetGainSliderLabel();
			break;
		case B_SIMPLE_DATA:
			break;
   		default:
			BView::MessageReceived(message);
			break;
	}
}
